\version "2.24.1"

#(begin

 (define edition
   (lambda (parent alist)
     (map
       (lambda (x)
         (if (not (ly:music? (cdr x)))
           (edition (format #f "~a.~a" parent (car x)) (cdr x))
           (let* ((music (format #f "~a.~a" parent (car x)))
                  (ly    (format #f "~a = \\keepWithTag #(list Edition score?) \\~a" music music)))
             (ly:parser-include-string ly))))
       alist)))

 (let* ((score     (ly:gulp-file (format #f "~3,'0d-score.ly" N))) ; read this score
        (book      (substring score (string-contains score "\\book"))) ; retain only part starting \book
        (matches   (map match:substring (list-matches "[IV]+[a-z]?.structure" book))) ; list of matches to regex
        (mvts      (map (lambda (match) (string-drop-right match (string-length ".structure"))) matches))) ; extract movement name
   (for-each (lambda (mvt) (edition mvt (ly:parser-lookup (string->symbol mvt)))) mvts)
 )

)
